/**
 * @author Hans Dulimarta
 * @version Winter 2006
 */
public class PrimeFactorization
{
	// pre-cond : V > 1
	// post-cond: prime factors of V are printed
	/**
	 * Prints out the prime factors of the given number. For example:
		<pre>
		2 = 2^1
		3 = 3^1
		4 = 2^2
		5 = 5^1
		6 = 2^1 3^1
		7 = 7^1
		8 = 2^3
		9 = 3^2
		10 = 2^1 5^1
		11 = 11^1
		12 = 2^2 3^1
		...
    	</pre>
	 * @param num The number to factor
	 */
	public static void printPrimeFactors(int num)
	{
		int factorCandidate;
		factorCandidate = 2;
		System.out.print(num + " = ");
		while (num > 1) // as long as num is factorizable
		{
			int cnt = 0;

			// as long as num is divisible by the current factor
			while (num % factorCandidate == 0)
			{
				cnt = 0;

				// divide that number with the factor
				cnt = num / factorCandidate;
				cnt++;
			}

			// if num is NOT divisible by the current factor anymore
			if (cnt > 1)
				System.out.print(factorCandidate + "^"+cnt+ " ");

			factorCandidate++; //try the next factor
		}
		// num <= 1  i.e. num is not factorizable anymore
		System.out.println();
	}

	public static void main (String[] args)
	{
		// Test the method with number 2, 3, ..., 39
		for (int i = 2; i < 40; i++)
			printPrimeFactors(i);
	}
}
